// media/mojo/mojom/interface_factory.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_INTERFACE_FACTORY_MOJOM_BLINK_H_
#define MEDIA_MOJO_MOJOM_INTERFACE_FACTORY_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "media/mojo/mojom/interface_factory.mojom-features.h"  // IWYU pragma: export
#include "media/mojo/mojom/interface_factory.mojom-shared.h"  // IWYU pragma: export
#include "media/mojo/mojom/interface_factory.mojom-blink-forward.h"  // IWYU pragma: export
#include "media/mojo/mojom/audio_decoder.mojom-blink-forward.h"
#include "media/mojo/mojom/audio_encoder.mojom-blink-forward.h"
#include "media/mojo/mojom/decryptor.mojom-blink-forward.h"
#include "media/mojo/mojom/content_decryption_module.mojom-blink-forward.h"
#include "media/mojo/mojom/media_log.mojom-blink-forward.h"
#include "media/mojo/mojom/media_types.mojom-blink-forward.h"
#include "media/mojo/mojom/renderer.mojom-blink-forward.h"
#include "media/mojo/mojom/renderer_extensions.mojom-blink-forward.h"
#include "media/mojo/mojom/stable/stable_video_decoder.mojom-blink-forward.h"
#include "media/mojo/mojom/video_decoder.mojom-blink-forward.h"
#include "mojo/public/mojom/base/token.mojom-blink-forward.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/platform/web_common.h"




namespace media::mojom::blink {

class InterfaceFactoryProxy;

template <typename ImplRefTraits>
class InterfaceFactoryStub;

class InterfaceFactoryRequestValidator;
class InterfaceFactoryResponseValidator;


class BLINK_PLATFORM_EXPORT InterfaceFactory
    : public InterfaceFactoryInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = InterfaceFactoryInterfaceBase;
  using Proxy_ = InterfaceFactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = InterfaceFactoryStub<ImplRefTraits>;

  using RequestValidator_ = InterfaceFactoryRequestValidator;
  using ResponseValidator_ = InterfaceFactoryResponseValidator;
  enum MethodMinVersions : uint32_t {
    kCreateAudioDecoderMinVersion = 0,
    kCreateVideoDecoderMinVersion = 0,
    kCreateStableVideoDecoderMinVersion = 0,
    kCreateAudioEncoderMinVersion = 0,
    kCreateDefaultRendererMinVersion = 0,
    kCreateCdmMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct CreateAudioDecoder_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateVideoDecoder_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateStableVideoDecoder_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateAudioEncoder_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateDefaultRenderer_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct CreateCdm_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~InterfaceFactory() = default;

  
  virtual void CreateAudioDecoder(::mojo::PendingReceiver<::media::mojom::blink::AudioDecoder> audio_decoder) = 0;

  
  virtual void CreateVideoDecoder(::mojo::PendingReceiver<::media::mojom::blink::VideoDecoder> video_decoder, ::mojo::PendingRemote<::media::stable::mojom::blink::StableVideoDecoder> dst_video_decoder) = 0;

  
  virtual void CreateStableVideoDecoder(::mojo::PendingReceiver<::media::stable::mojom::blink::StableVideoDecoder> video_decoder) = 0;

  
  virtual void CreateAudioEncoder(::mojo::PendingReceiver<::media::mojom::blink::AudioEncoder> audio_encoder) = 0;

  
  virtual void CreateDefaultRenderer(const WTF::String& audio_device_id, ::mojo::PendingReceiver<::media::mojom::blink::Renderer> renderer) = 0;


  using CreateCdmCallback = base::OnceCallback<void(::mojo::PendingRemote<::media::mojom::blink::ContentDecryptionModule>, ::media::mojom::blink::CdmContextPtr, ::media::mojom::blink::CreateCdmStatus)>;
  
  virtual void CreateCdm(::media::mojom::blink::CdmConfigPtr cdm_config, CreateCdmCallback callback) = 0;
};



class BLINK_PLATFORM_EXPORT InterfaceFactoryProxy
    : public InterfaceFactory {
 public:
  using InterfaceType = InterfaceFactory;

  explicit InterfaceFactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void CreateAudioDecoder(::mojo::PendingReceiver<::media::mojom::blink::AudioDecoder> audio_decoder) final;
  
  void CreateVideoDecoder(::mojo::PendingReceiver<::media::mojom::blink::VideoDecoder> video_decoder, ::mojo::PendingRemote<::media::stable::mojom::blink::StableVideoDecoder> dst_video_decoder) final;
  
  void CreateStableVideoDecoder(::mojo::PendingReceiver<::media::stable::mojom::blink::StableVideoDecoder> video_decoder) final;
  
  void CreateAudioEncoder(::mojo::PendingReceiver<::media::mojom::blink::AudioEncoder> audio_encoder) final;
  
  void CreateDefaultRenderer(const WTF::String& audio_device_id, ::mojo::PendingReceiver<::media::mojom::blink::Renderer> renderer) final;
  
  void CreateCdm(::media::mojom::blink::CdmConfigPtr cdm_config, CreateCdmCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT InterfaceFactoryStubDispatch {
 public:
  static bool Accept(InterfaceFactory* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      InterfaceFactory* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<InterfaceFactory>>
class InterfaceFactoryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  InterfaceFactoryStub() = default;
  ~InterfaceFactoryStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return InterfaceFactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return InterfaceFactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT InterfaceFactoryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT InterfaceFactoryResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // media::mojom::blink

namespace mojo {

}  // namespace mojo

#endif  // MEDIA_MOJO_MOJOM_INTERFACE_FACTORY_MOJOM_BLINK_H_