// services/network/public/mojom/document_isolation_policy.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_DOCUMENT_ISOLATION_POLICY_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_DOCUMENT_ISOLATION_POLICY_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/document_isolation_policy.mojom-features.h"  // IWYU pragma: export
#include "services/network/public/mojom/document_isolation_policy.mojom-shared.h"  // IWYU pragma: export
#include "services/network/public/mojom/document_isolation_policy.mojom-forward.h"  // IWYU pragma: export
#include "url/mojom/url.mojom-forward.h"
#include "services/network/public/mojom/fetch_api.mojom-forward.h"
#include <string>
#include <vector>




#include "services/network/public/cpp/document_isolation_policy_mojom_traits.h"




namespace network::mojom {





class  DocumentIsolationPolicy {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DocumentIsolationPolicy, T>::value>;
  using DataView = DocumentIsolationPolicyDataView;
  using Data_ = internal::DocumentIsolationPolicy_Data;

  template <typename... Args>
  static DocumentIsolationPolicyPtr New(Args&&... args) {
    return DocumentIsolationPolicyPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DocumentIsolationPolicyPtr From(const U& u) {
    return mojo::TypeConverter<DocumentIsolationPolicyPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DocumentIsolationPolicy>::Convert(*this);
  }


  DocumentIsolationPolicy();

  DocumentIsolationPolicy(
      DocumentIsolationPolicyValue value,
      const std::optional<std::string>& reporting_endpoint,
      DocumentIsolationPolicyValue report_only_value,
      const std::optional<std::string>& report_only_reporting_endpoint);


  ~DocumentIsolationPolicy();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DocumentIsolationPolicyPtr>
  DocumentIsolationPolicyPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DocumentIsolationPolicy::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DocumentIsolationPolicy::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DocumentIsolationPolicy_UnserializedMessageContext<
            UserType, DocumentIsolationPolicy::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DocumentIsolationPolicy::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(base::span<const uint8_t> input,
                          UserType* output) {
    return DocumentIsolationPolicy::Deserialize(
        input.empty() ? nullptr : input.data(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DocumentIsolationPolicy_UnserializedMessageContext<
            UserType, DocumentIsolationPolicy::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DocumentIsolationPolicy::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  DocumentIsolationPolicyValue value;
  
  std::optional<std::string> reporting_endpoint;
  
  DocumentIsolationPolicyValue report_only_value;
  
  std::optional<std::string> report_only_reporting_endpoint;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DocumentIsolationPolicy::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
DocumentIsolationPolicyPtr DocumentIsolationPolicy::Clone() const {
  return New(
      mojo::Clone(value),
      mojo::Clone(reporting_endpoint),
      mojo::Clone(report_only_value),
      mojo::Clone(report_only_reporting_endpoint)
  );
}

template <typename T, DocumentIsolationPolicy::EnableIfSame<T>*>
bool DocumentIsolationPolicy::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  if (!mojo::Equals(this->reporting_endpoint, other_struct.reporting_endpoint))
    return false;
  if (!mojo::Equals(this->report_only_value, other_struct.report_only_value))
    return false;
  if (!mojo::Equals(this->report_only_reporting_endpoint, other_struct.report_only_reporting_endpoint))
    return false;
  return true;
}

template <typename T, DocumentIsolationPolicy::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  if (lhs.reporting_endpoint < rhs.reporting_endpoint)
    return true;
  if (rhs.reporting_endpoint < lhs.reporting_endpoint)
    return false;
  if (lhs.report_only_value < rhs.report_only_value)
    return true;
  if (rhs.report_only_value < lhs.report_only_value)
    return false;
  if (lhs.report_only_reporting_endpoint < rhs.report_only_reporting_endpoint)
    return true;
  if (rhs.report_only_reporting_endpoint < lhs.report_only_reporting_endpoint)
    return false;
  return false;
}


}  // network::mojom

namespace mojo {


template <>
struct  StructTraits<::network::mojom::DocumentIsolationPolicy::DataView,
                                         ::network::mojom::DocumentIsolationPolicyPtr> {
  static bool IsNull(const ::network::mojom::DocumentIsolationPolicyPtr& input) { return !input; }
  static void SetToNull(::network::mojom::DocumentIsolationPolicyPtr* output) { output->reset(); }

  static decltype(::network::mojom::DocumentIsolationPolicy::value) value(
      const ::network::mojom::DocumentIsolationPolicyPtr& input) {
    return input->value;
  }

  static const decltype(::network::mojom::DocumentIsolationPolicy::reporting_endpoint)& reporting_endpoint(
      const ::network::mojom::DocumentIsolationPolicyPtr& input) {
    return input->reporting_endpoint;
  }

  static decltype(::network::mojom::DocumentIsolationPolicy::report_only_value) report_only_value(
      const ::network::mojom::DocumentIsolationPolicyPtr& input) {
    return input->report_only_value;
  }

  static const decltype(::network::mojom::DocumentIsolationPolicy::report_only_reporting_endpoint)& report_only_reporting_endpoint(
      const ::network::mojom::DocumentIsolationPolicyPtr& input) {
    return input->report_only_reporting_endpoint;
  }

  static bool Read(::network::mojom::DocumentIsolationPolicy::DataView input, ::network::mojom::DocumentIsolationPolicyPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_DOCUMENT_ISOLATION_POLICY_MOJOM_H_