// services/viz/public/mojom/compositing/tiling.mojom-shared-internal.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_TILING_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_TILING_MOJOM_SHARED_INTERNAL_H_
#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/viz/public/mojom/compositing/transferable_resource.mojom-shared-internal.h"
#include "skia/public/mojom/skcolor4f.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}


namespace viz::mojom {
namespace internal {
class TileResource_Data;
class Tile_Data;
class Tiling_Data;
class TileContents_Data;

struct MissingTileReason_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)


class  TileContents_Data {
 public:
  // Used to identify Mojom Union Data Classes.
  typedef void MojomUnionDataType;

  TileContents_Data() = default;
  // Do nothing in the destructor since it won't be called when it is a
  // non-inlined union.
  ~TileContents_Data() = default;

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context,
                       bool inlined);

  bool is_null() const { return size == 0; }

  void set_null() {
    size = 0U;
    tag = static_cast<TileContents_Tag>(0);
    data.unknown = 0U;
  }

  // TODO(crbug.com/40731316): SHOUTY_CASE values are being deprecated per C++ code style
  // guidelines (https://google.github.io/styleguide/cppguide.html#Enumerator_Names),
  // please use kCamelCase values instead.  Cleanup NULL_VALUE, BOOL_VALUE, INT_VALUE, etc.
  // generation once codebase is transitioned to kNullValue, kBoolValue, kIntValue, etc.
  enum class TileContents_Tag : uint32_t {

    
    kMissingReason,
    
    kResource,
    
    kSolidColor,
  };

  // A note on layout:
  // "Each non-static data member is allocated as if it were the sole member of
  // a struct." - Section 9.5.2 ISO/IEC 14882:2011 (The C++ Spec)
  union MOJO_ALIGNAS(8) Union_ {
    Union_() : unknown(0) {}
    int32_t f_missing_reason;
    mojo::internal::Pointer<internal::TileResource_Data> f_resource;
    mojo::internal::Pointer<::skia::mojom::internal::SkColor4f_Data> f_solid_color;
    uint64_t unknown;
  };

  uint32_t size;
  TileContents_Tag tag;
  Union_ data;
};
static_assert(sizeof(TileContents_Data) == mojo::internal::kUnionDataSize,
              "Bad sizeof(TileContents_Data)");
class  TileResource_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::TransferableResource_Data> resource;
  uint8_t is_premultiplied : 1;
  uint8_t is_checkered : 1;
  uint8_t padfinal_[7];

 private:
  friend class mojo::internal::MessageFragment<TileResource_Data>;

  TileResource_Data();
  ~TileResource_Data() = delete;
};
static_assert(sizeof(TileResource_Data) == 24,
              "Bad sizeof(TileResource_Data)");
// Used by TileResource::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct TileResource_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  TileResource_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~TileResource_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<TileResource_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    TileResource_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  Tile_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t column_index;
  uint32_t row_index;
  internal::TileContents_Data contents;

 private:
  friend class mojo::internal::MessageFragment<Tile_Data>;

  Tile_Data();
  ~Tile_Data() = delete;
};
static_assert(sizeof(Tile_Data) == 32,
              "Bad sizeof(Tile_Data)");
// Used by Tile::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct Tile_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  Tile_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~Tile_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<Tile_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    Tile_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  Tiling_Data {
 public:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t layer_id;
  mojo::internal::Pointer<::gfx::mojom::internal::Vector2dF_Data> raster_translation;
  mojo::internal::Pointer<::gfx::mojom::internal::Vector2dF_Data> raster_scale;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> tile_size;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> tiling_rect;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::Tile_Data>>> tiles;

 private:
  friend class mojo::internal::MessageFragment<Tiling_Data>;

  Tiling_Data();
  ~Tiling_Data() = delete;
};
static_assert(sizeof(Tiling_Data) == 56,
              "Bad sizeof(Tiling_Data)");
// Used by Tiling::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct Tiling_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  Tiling_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~Tiling_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::Message& message) override {
    mojo::internal::MessageFragment<Tiling_Data> fragment(message);
    mojo::internal::Serialize<DataView>(user_data_, fragment);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    Tiling_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal

}  // viz::mojom

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_TILING_MOJOM_SHARED_INTERNAL_H_